.NET

Reply
Contributor
annse
Posts: 18
Registered: ‎04-04-2012
Message 1 of 18 (537 Views)
Accepted Solution

Override default commands

537 Views, 17 Replies
04-04-2012 03:01 AM

Hi!

 

I'm trying to do something like this:

 

[Autodesk.AutoCAD.Runtime.CommandMethod("REFEDIT", Autodesk.AutoCAD.Runtime.CommandFlags.UsePickSet)]
public void RefEdit()
{
Document doc = AcadApp.DocumentManager.MdiActiveDocument;

 

if (doc is a document I care about))
{
do my stuff...
}
else
{

run the default command...
}
}

 

I haven't undefined the default command, my definition of REFEDIT executes anyway.

I wanna be able to run the default command from my definition.

 

doc.SendStringToExecute(".REFEDIT ", true, false, false); will loop forever.

 

This code was tested with AutoCAD 2011-2013:

 

using System;

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.EditorInput;

 

[assembly: ExtensionApplication(typeof(Rivilis.RefEditSubst))]

[assembly: CommandClass(typeof(Rivilis.RefEditSubst))]

 

namespace Rivilis

{

    public class RefEditSubst : IExtensionApplication

    {

        void IExtensionApplication.Initialize()

        {

            // Preloading AutoCAD RefEdit command arx-file

            SystemObjects.DynamicLinker.LoadModule("AcRefEd.arx", false, false);

        }

        void IExtensionApplication.Terminate()

        {

            // Do plug-in application clean up here

        }

        //------------------------------------------------

        //     Command group MUST be "ACAD_MAIN"

        //------------------------------------------------

        [CommandMethod("ACAD_MAIN", "RefEdit", CommandFlags.UsePickSet)]

        public void RefEdit() // This method can have any name

        {

            Document doc = Application.DocumentManager.MdiActiveDocument;

            Editor ed = doc.Editor;

            ed.WriteMessage("MyRefEdit..");

            if (doc.Name.Contains("Test"))

            {

                ed.WriteMessage("selected ref..");

            }

            else

            {

                doc.SendStringToExecute("_ACAD_REFEDIT.REFEDIT ", true, false, false);

            }

        }

 

    }

}

ADN Support Specialist
Balaji_Ram
Posts: 733
Registered: ‎03-21-2011
Message 2 of 18 (529 Views)

Re: Override default commands

04-04-2012 05:40 AM in reply to: annse

Hi,

 

I tried this which is very similar to what you are trying and it worked ok.

With this code, the line command is redefined only for drawings that have "Test" in their name.

 

Can you try this and see if it works for you ?

Maybe it will then help you identify the reason for your code to loop indefinitely.

 

// Add reference to Autodesk.AutoCAD.Interop 
// Add reference to Autodesk.AutoCAD.Interop.Common
using Autodesk.AutoCAD.Interop;
using Autodesk.AutoCAD.Interop.Common;

[CommandMethod("LINE")]
static public void LineMethod()
{
    Document doc = Application.DocumentManager.MdiActiveDocument;
    Editor ed = doc.Editor;
    if (doc.Name.Contains("Test"))
        ed.WriteMessage("My implementation of line");
    else
    {
        AcadApplication app = (AcadApplication)Application.AcadApplication;
        app.ActiveDocument.SendCommand("_.LINE ");
        ed.WriteMessage("My implementation of line");
    }
}
    
void IExtensionApplication.Initialize()
{
    AcadApplication app = (AcadApplication)Application.AcadApplication;
    app.ActiveDocument.SendCommand("_.UNDEFINE _LINE ");
}

 

 

 



Balaji
Developer Technical Services
Autodesk Developer Network

Contributor
annse
Posts: 18
Registered: ‎04-04-2012
Message 3 of 18 (519 Views)

Re: Override default commands

04-04-2012 06:58 AM in reply to: Balaji_Ram

Thank you for your quick response!

 

I've added required references and I now use SendCommand instead of SendStringToExecute.

This will still loop indefinitely. (If doc.Name doesn't contain "Test")

 

public void Initialize()
{

AcadApplication app = (AcadApplication)Application.AcadApplication;
app.ActiveDocument.SendCommand("_.UNDEFINE _REFEDIT ");
}

 

[Autodesk.AutoCAD.Runtime.CommandMethod("REFEDIT", Autodesk.AutoCAD.Runtime.CommandFlags.UsePickSet)]
static public void RefEdit()
{
Document doc = AcadApp.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;

 

if (doc.Name.Contains("Test"))
{
ed.WriteMessage("New refedit...");
}
else
{
AcadApplication app = (AcadApplication)Application.AcadApplication;
app.ActiveDocument.SendCommand("_.REFEDIT ");
}
}

 

Thanks again!

ADN Support Specialist
Balaji_Ram
Posts: 733
Registered: ‎03-21-2011
Message 4 of 18 (513 Views)

Re: Override default commands

04-04-2012 08:36 AM in reply to: annse

Hi,

 

With the Line command the code does work.

 

But there seems to be some problem with using it for "Refedit".

Can you check if the command is actually undefined after sending the "undefine" command ?

 

 

 



Balaji
Developer Technical Services
Autodesk Developer Network

Moderator
Alexander.Rivilis
Posts: 1,446
Registered: ‎04-09-2008
Message 5 of 18 (501 Views)

Re: Override default commands

04-04-2012 11:42 AM in reply to: Balaji_Ram

What about:

app.ActiveDocument.SendCommand("_ACAD_REFEDIT.REFEDIT ");

 ?

Command _REFEDIT defined in file AcRefEd.arx

If your's dll-file loaded after AcRefEd.arx - than no need to _UNDEFINE _REFEDIT, because your command REFEDIT override standard command REFEDIT. And standard command REFEDIT can be invoked using _ACAD_REFEDIT.REFEDIT


Пожалуйста не забывайте про Утвердить в качестве решения! Утвердить в качестве решения и Give Kudos!Баллы
Please remember to Accept Solution! Accept as Solution and Give Kudos!Kudos

Contributor
annse
Posts: 18
Registered: ‎04-04-2012
Message 6 of 18 (483 Views)

Re: Override default commands

04-04-2012 11:32 PM in reply to: Balaji_Ram

Hi!

 

When I do the same thing with LINE instead of REFEDIT, my new definition of LINE won't run.

I get this error with both LINE and REFEDIT.

 

_.UNDEFINE
; error: no function definition: ACET-STR-REPLACE
_LINE

 

Thanks!

Contributor
annse
Posts: 18
Registered: ‎04-04-2012
Message 7 of 18 (480 Views)

Re: Override default commands

04-04-2012 11:46 PM in reply to: Alexander.Rivilis

Thanks, Alexander! That works!

 

My dll is loaded in a .bundle installation.

So, because I can't override _LINE the same way, _LINE is loaded after my dll and _REFEDIT before?

 

Thanks again!

Contributor
annse
Posts: 18
Registered: ‎04-04-2012
Message 8 of 18 (474 Views)

Re: Override default commands

04-05-2012 12:29 AM in reply to: Alexander.Rivilis

If the timing issue is irrelevant due to that the _REFEDIT command is already defined when my dll is loading,

I can use SendStringToExecute instead of SendCommand?

This way I won't have to echo the command.

 

Thanks again!

Moderator
Alexander.Rivilis
Posts: 1,446
Registered: ‎04-09-2008
Message 9 of 18 (470 Views)

Re: Override default commands

04-05-2012 12:39 AM in reply to: annse

annse wrote:

I can use SendStringToExecute instead of SendCommand?

This way I won't have to echo the command.


I think you can do it. Try!  :-)


Пожалуйста не забывайте про Утвердить в качестве решения! Утвердить в качестве решения и Give Kudos!Баллы
Please remember to Accept Solution! Accept as Solution and Give Kudos!Kudos

Contributor
annse
Posts: 18
Registered: ‎04-04-2012
Message 10 of 18 (462 Views)

Re: Override default commands

04-05-2012 03:32 AM in reply to: Alexander.Rivilis

Hello again...

 

Sending "_ACAD_REFEDIT.REFEDIT " seems to redefine the command.

If the string is executed, the next time you run REFEDIT, it'll run the default definition. 

 

[Autodesk.AutoCAD.Runtime.CommandMethod("REFEDIT", Autodesk.AutoCAD.Runtime.CommandFlags.Session & Autodesk.AutoCAD.Runtime.CommandFlags.UsePickSet)]
static public void RefEditDef()
{
Document doc = Application.DocumentManager.MdiActiveDocument;
Editor ed = doc.Editor;

 

if (doc.Name.Contains("Test"))
{

ed.WriteMessage("selected ref..");

}
else
{
doc.SendStringToExecute("_ACAD_REFEDIT.REFEDIT ", true, false, false);
}
}

 

Any ideas?

 

Thanks!

Post to the Community

Have questions about Autodesk products? Ask the community.

New Post
Announcements
Are You Going To Be @ AU 2014? Feel free to drop by our AU topic post and share your plans, plug a class that you're teaching, or simply check out who else from the community might be in attendance. Ohh and don't forgot to stop by the Autodesk Help | Learn | Collaborate booths in the Exhibit Hall and meet our community team if you get a chance!